
Components.utils.import("resource://gre/modules/ctypes.jsm");
var is64bit = ( ctypes.voidptr_t.size == 8 );
var WinABI  = is64bit ? ctypes.default_abi : ctypes.winapi_abi;

console.log( "antFF::overlay.js::start x" + ( is64bit ? "64" : "32" ) );

var dllpath;
var winReg = Components.classes["@mozilla.org/windows-registry-key;1"]
                       .createInstance( Components.interfaces.nsIWindowsRegKey );
if ( winReg )
{
	winReg.open( winReg.ROOT_KEY_CURRENT_USER, "Software\\AntGROUP\\Downloader", winReg.ACCESS_READ );
	if ( winReg.hasValue( "AppFolder" ) )
	{
		dllpath = winReg.readStringValue( "AppFolder" ) + "\\antFF\\";
		dllpath = dllpath + ( is64bit ? "antFF64.dll" : "antFF.dll" );	
	}	
	winReg.close();
}

//console.log( "antFF::overlay.js dllpath=" + dllpath );
var antFFdll = ctypes.open( dllpath );
if ( !antFFdll || antFFdll.declare( "IsInit", WinABI, ctypes.int32_t )() == false ) 
	throw new Error( "ERROR::overlay.js error init " + dllpath );

try
{
	var antFFMenu  = Cc["@antff/menu_gateway;1" ].getService().QueryInterface( Ci.IFFMenu ); 
	var antFFEvent = Cc["@antff/event_gateway;1"].getService().QueryInterface( Ci.IFFEvent ); 
											
	window.addEventListener( "load", function() { PopupMenu.Init(); }, false );
	window.messageManager.loadFrameScript( "chrome://antff/content/content.js", true );
}
catch( err ) { console.error( "ERROR::overlay.js name=" + err.name + " message=" + err.message + "\nstack=" + err.stack ); }


var PopupMenu = 
{
  Init : function() 
  {
    var menu = document.getElementById( "contentAreaContextMenu" );
    menu.addEventListener( "popupshowing", this.contentPopupShowing, false );
  },
  contentPopupShowing : function()  
  {
		try
		{
			let antFFMenu = Cc["@antff/menu_gateway;1"].getService( Ci.IFFMenu ); 
			if ( antFFMenu.IsHelperInit() == true ) 
			{
				let obj = document.getElementById( "id_antff_separator" );
				if ( obj ) obj.remove();
				obj = document.getElementById( "id_antff_download"  );
				if ( obj ) obj.remove();
				console.log( "antFF::overlay.js::helper working" );
				return;
			}
			//console.log( "ERROR::overlay.js contentPopupShowing name=" + antFFMenu.IsHelperInit() );
		}
		catch( err ) { console.error( "ERROR::overlay.js name=" + err.name + " message=" + err.message + "\nstack=" + err.stack ); }
		
		document.getElementById( "id_antff_download"     			).label = antFFMenu.GetDownloadLabel();
		
		var DLinkLabel = antFFMenu.GetDownloadLinkLabel( document.popupNode );
		document.getElementById( "id_antff_download_link"     ).label  = DLinkLabel;
		document.getElementById( "id_antff_download_link"     ).hidden = DLinkLabel == "";

		var DSelLabel  = antFFMenu.GetDownloadSelectedLabel( window );
		document.getElementById( "id_antff_download_selected" ).label  = DSelLabel;
		document.getElementById( "id_antff_download_selected" ).hidden = DSelLabel == "";		

		var DAllLabel  = antFFMenu.GetDownloadAllLabel( window );
		document.getElementById( "id_antff_download_all" 			).label  = DAllLabel;
		document.getElementById( "id_antff_download_all" 			).hidden = DAllLabel == "";		

		document.getElementById( "id_antff_download"     			).hidden = DLinkLabel == "" && DSelLabel == "" && DAllLabel == "";
		document.getElementById( "id_antff_separator"					).hidden = DLinkLabel == "" && DSelLabel == "" && DAllLabel == "";
	}
}

function DownloadLink() 
{
  try
  {
    antFFMenu.DownloadLink( 
      document.commandDispatcher.focusedWindow.document,
      document.popupNode );
  }
  catch( err ) { console.error( "ERROR::overlay.js name=" + err.name + " message=" + err.message + "\nstack=" + err.stack ); }
}

function DownloadSelected() 
{
  try
  {
    antFFMenu.DownloadSelected( document.commandDispatcher.focusedWindow );
  }
  catch( err ) { console.error( "ERROR::overlay.js name=" + err.name + " message=" + err.message + "\nstack=" + err.stack ); }
}

function DownloadAll() 
{
  try
  {
		antFFMenu.DownloadAll( document.commandDispatcher.focusedWindow );
  }
  catch( err ) { console.error( "ERROR::overlay.js name=" + err.name + " message=" + err.message + "\nstack=" + err.stack ); }
}


//
// *** GATEWAY *** GATEWAY *** GATEWAY *** GATEWAY *** GATEWAY *** GATEWAY *** GATEWAY ***
//
var Gateway = 
{
  Init : function() 
  {
		window.addEventListener( "TabSelect", this.TabSelect, true );
		window.addEventListener( "TabOpen",   this.TabOpen,   this );
	
    var obj = Cc["@mozilla.org/parentprocessmessagemanager;1"].getService( Ci.nsIMessageBroadcaster );
								
    obj.addMessageListener( "antff_gw_tabselect", this );
		obj.addMessageListener( "antff_gw_resize", this );
		obj.addMessageListener( "antff_gw_scroll", 	  this );
		obj.addMessageListener( "antff_gw_mousemove", this );
		//obj.addMessageListener( "antff_gw_contentld", this );
		//obj.addMessageListener( "antff_gw_pageshow",  this );
		obj.addMessageListener( "antff_gw_mozvisibilitychange",this );
	
  },
  receiveMessage: function ( mes ) 
	{
    switch ( mes.name ) 
		{
      case "antff_gw_tabselect":
				//console.log( "antFF::overlay.js::Gateway::antff_gw_tabselect tabid=" + mes.objects.tabid );
				antFFEvent.TabSelect( mes.objects.tabid );
        break;
      case "antff_gw_scroll":
				//console.log( "antFF::overlay.js::Gateway::antff_gw_scroll" );
				antFFEvent.Scroll( mes.objects.tabid );
				break;
      case "antff_gw_resize":
				//console.log( "antFF::overlay.js::Gateway::antff_gw_resize tabid=" + mes.objects.tabid );
				antFFEvent.Resize( mes.objects.tabid );
				break;
      case "antff_gw_mousemove":
				//console.log( "antFF::overlay.js::Gateway::antff_gw_mousemove tabid=" + mes.objects.tabid );
				antFFEvent.MouseMove( mes.objects.tabid );
        break;				
			case "antff_gw_mozvisibilitychange":
				//console.log( "antFF::overlay.js::Gateway::antff_gw_mozvisibilitychange tabid=" + mes.objects.tabid + " hidden=" + mes.objects.hidden1 );
				//console.log( "antFF::overlay.js::Gateway::antff_gw_mozvisibilitychange tabid=" + mes.objects.tabid + " visible=" + mes.objects.visible );
        antFFEvent.TabShow( mes.objects.tabid, mes.objects.visible );
				break;				
    }
  },
	TabOpen : function() 
  {
		//console.log( "antFF::overlay.js::Gateway::TabOpen" );
		//antFFEvent.TabOpen();
  },
	TabSelect : function() 
  {
		//console.log( "antFF::overlay.js::Gateway::TabSelect" );
		gBrowser.selectedBrowser.messageManager.sendAsyncMessage( "antff_gw_get_tabselect" );
  }

}
Gateway.Init();
